=== debian/watch ===
Version: 5

Source: https://github.com/JACoders/OpenJK
Compression: xz
Dversion-Mangle: s/[~+](dfsg|ds)[0-9]*$//
Git-Pretty: 0~%cd.%h
Matching-Pattern: HEAD
Mode: git
Repack-Suffix: +dfsg
